#include "/85/lib/usgard.h"
#include "/85/lib/ugapplib.h"

.org 0
.db "Ramdom v5.0 TSR",0
.db 69,6,1,UGAPPLIB,0

Start:
	call	CLEARLCD
	ld	hl, VIDEO_MEM
	ld	b, 112
FillLoop:
	ld	(hl), 255
	inc	hl
	djnz	FillLoop

	ld	hl, $0020
	ld	(CURSOR_X), hl

	set	3, (iy+5)
	ld	hl, (PROGRAM_ADDR)	;PROGRAM_ADDR = Title
	call	D_ZM_STR
	res	3, (iy+5)

;Check if TSR is already installed using CHECK_APPEND.
; HL -> code to check(we only check the unmodified one)
; BC -> length of code.
        ld      hl, &TSRRoutine
        ld      bc, RoutineEnd-TSRRoutine
	LIB_CALL_(UGAPPLIB,CHECK_APPEND)
	jr	z, InstallTSR
	jr	nc, NotAtTheEnd
	jr	nz, RemoveTSR		;TSR already installed?

InstallTSR:
	ld	hl, $0001
	ld	(CURSOR_ROW), hl
	ld	hl, &InstTxt
	call	D_ZT_STR
        ld      hl, $0002
        ld      (CURSOR_ROW), hl
        ld      hl, &InstTxt2
        call    D_ZT_STR
Choice:
	call	GET_KEY
	cp	K_EXIT
	ret	z
	cp	K_ENTER
        jr      nz, Choice

Done:
	ld	hl, &TSRRoutine		;use the & operator to add (PROGRAM_ADDR)
	ld	bc, RoutineEnd-TSRRoutine
	LIB_CALL_(UGAPPLIB,APPEND)	;append the TSR code to Usgard!
	call	INT_INSTALL

	ld	hl, &Installed

WriteText:
	ld	de, $0003
	ld	(CURSOR_ROW), de

	call	D_ZT_STR

	call	OTH_PAUSE
	ret
RemoveTSR:
	call	INT_REMOVE

	ld	bc, RoutineEnd-TSRRoutine
	LIB_CALL_(UGAPPLIB,UNAPPEND)

	ld	hl, &Removed
	jr      WriteText

NotAtTheEnd:
	ld	hl, &NotAtEnd
	jr	WriteText


TSRRoutine:
	in      a, (3)                  ;Check ON
	bit     3, a
	ret     nz
	ld      a, %10111111            ;Check F1
	out     (1), a
	in      a, (1)
	bit     4, a
	ret     nz
        push    ix
        push    iy
        LIB_CALL_(69, 0)
        pop     iy
        pop     ix
        ret

RoutineEnd:

Installed:
	;012345678901234567890
 .db    "Press ON+F1 to Run",0
InstTxt:
 .db    "Enter Installs",0
InstTxt2:
 .db    "Otherwise EXIT",0
Removed:
 .db	"Removed",0
NotAtEnd:
 .db	"Not at the end!",0
.end
